org.richfaces.component

## Class AbstractTooltip

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - javax.faces.component.UIOutput
      - - org.richfaces.component.AbstractTooltip

- All Implemented Interfaces:
    EventListener, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.component.ValueHolder, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListenerHolder, AbstractDivPanel, AjaxActivatorProps, AjaxProps, CoreProps, EventsMouseProps, EventsPopupsBeforeProps, EventsPopupsProps, I18nProps, PopupsProps, PositionProps, MetaComponentEncoder, MetaComponentResolver
  Direct Known Subclasses:
    UITooltip

      public abstract class AbstractTooltip
      extends javax.faces.component.UIOutput
      implements AbstractDivPanel, MetaComponentResolver, MetaComponentEncoder, AjaxProps, CoreProps, EventsMouseProps, EventsPopupsProps, EventsPopupsBeforeProps, I18nProps, PopupsProps, PositionProps

  The <rich:tooltip> component provides an informational tool-tip. The tool-tip can be attached to any control and is displayed when hovering the mouse cursor over the control.

  Author:
    amarkhel

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `COMPONENT_FAMILY`
    `static String` | `COMPONENT_TYPE`
    `static String` | `CONTENT_META_COMPONENT_ID`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

    - ### Fields inherited from interface org.richfaces.component.MetaComponentResolver

      `META_COMPONENT_SEPARATOR_CHAR`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractTooltip()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `encodeMetaComponent(javax.faces.context.FacesContext context, String metaComponentId)`
    `String` | `getContentClientId(javax.faces.context.FacesContext context)`
    `abstract javax.faces.convert.Converter` | `getConverter()`
    `abstract Positioning` | `getDirection()` Set the direction of the popup.
    `abstract Object` | `getExecute()` IDs of components that will participate in the "execute" portion of the Request Processing Lifecycle.
    `String` | `getFamily()`
    `abstract int` | `getHideDelay()` Delay in milliseconds before tooltip will be hidden.
    `abstract String` | `getHideEvent()` Event that triggers the tooltip disappearance.
    `abstract int` | `getHorizontalOffset()` Sets the horizontal offset between pop-up list and mouse pointer.
    `abstract Positioning` | `getJointPoint()` Set the corner attachment point with which the popup should be connected.
    `abstract TooltipLayout` | `getLayout()` Block/inline mode flag.
    `abstract TooltipMode` | `getMode()` Controls the way of data loading to a tooltip.
    `abstract int` | `getShowDelay()` Delay in milliseconds before tooltip will be displayed.
    `abstract String` | `getShowEvent()` Event that triggers the tooltip.
    `String` | `getTarget()` Component ID of the target component or "null" if the component should be attached to the parent component.
    `abstract int` | `getVerticalOffset()` Sets the vertical offset between pop-up list and mouse pointer.
    `abstract int` | `getZindex()` Attribute is similar to the standard HTML attribute and can specify window placement relative to the content.
    `abstract boolean` | `isAttached()` If the value of the "attached" attribute is "true", a component is attached to the parent component; if "false", component does not listen to activating browser events, but could be activated externally.
    `abstract boolean` | `isFollowMouse()` If "true" tooltip should follow the mouse while it moves over the parent element.
    `String` | `resolveClientId(javax.faces.context.FacesContext facesContext, javax.faces.component.UIComponent contextComponent, String metaComponentId)` Resolves and returns string identifying supported meta-component or `null` if provided meta-component name is not a supported one.
    `void` | `setTarget(String target)`
    `String` | `substituteUnresolvedClientId(javax.faces.context.FacesContext facesContext, javax.faces.component.UIComponent contextComponent, String metaComponentId)` Provides replacement for unresolved meta-component names.
    `boolean` | `visitTree(javax.faces.component.visit.VisitContext context, javax.faces.component.visit.VisitCallback callback)`

    - ### Methods inherited from class javax.faces.component.UIOutput

      `clearInitialState, getLocalValue, getValue, markInitialState, restoreState, saveState, setConverter, setValue`

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addClientBehavior, addFacesListener, broadcast, decode, encodeBegin, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getClientBehaviors, getClientId, getDefaultEventName, getEventNames, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getListenersForEventClass, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, invokeOnComponent, isRendered, isTransient, processDecodes, processRestoreState, processSaveState, processUpdates, processValidators, queueEvent, removeFacesListener, restoreAttachedState, saveAttachedState, setId, setParent, setRendered, setRendererType, setTransient, setValueBinding, subscribeToEvent, unsubscribeFromEvent`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getContainerClientId, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getResourceBundleMap, getStateHelper, getStateHelper, getTransientStateHelper, getTransientStateHelper, getValueExpression, initialStateMarked, isCompositeComponent, isInView, isVisitable, popComponentFromEL, processEvent, pushComponentToEL, restoreTransientState, saveTransientState, setInView, setValueExpression`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.richfaces.component.attribute.CoreProps

      `getStyle, getStyleClass, getTitle`

    - ### Methods inherited from interface org.richfaces.component.attribute.EventsMouseProps

      `getOnclick, getOndblclick, getOnmousedown, getOnmousemove, getOnmouseout, getOnmouseover, getOnmouseup`

    - ### Methods inherited from interface org.richfaces.component.attribute.I18nProps

      `getDir, getLang`

    - ### Methods inherited from interface org.richfaces.component.attribute.AjaxProps

      `getOnbegin, getStatus`

    - ### Methods inherited from interface org.richfaces.component.attribute.AjaxActivatorProps

      `getData, getOnbeforedomupdate, getOncomplete, getRender, isLimitRender`

    - ### Methods inherited from interface org.richfaces.component.attribute.EventsPopupsProps

      `getOnhide, getOnshow`

    - ### Methods inherited from interface org.richfaces.component.attribute.EventsPopupsBeforeProps

      `getOnbeforehide, getOnbeforeshow`

- - ### Field Detail

    - #### COMPONENT_TYPE

          public static final String COMPONENT_TYPE

      See Also:
        Constant Field Values

    - #### COMPONENT_FAMILY

          public static final String COMPONENT_FAMILY

      See Also:
        Constant Field Values

    - #### CONTENT_META_COMPONENT_ID

          public static final String CONTENT_META_COMPONENT_ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### AbstractTooltip

          protected AbstractTooltip()

  - ### Method Detail

    - #### getFamily

          public String getFamily()

      Overrides:
        `getFamily` in class `javax.faces.component.UIOutput`

    - #### getTarget

          public String getTarget()

      Component ID of the target component or "null" if the component should be attached to the parent component.

    - #### setTarget

          public void setTarget(String target)

    - #### getLayout

          public abstract TooltipLayout getLayout()

      Block/inline mode flag. Possible value are: "inline" or "block". Default value is "inline". Tooltip will contain div/span elements respectively.

    - #### isAttached

          public abstract boolean isAttached()

      If the value of the "attached" attribute is "true", a component is attached to the parent component; if "false", component does not listen to activating browser events, but could be activated externally. Default value is "true"

    - #### getJointPoint

          public abstract Positioning getJointPoint()

      Description copied from interface: `PositionProps`

      Set the corner attachment point with which the popup should be connected. Possible values are:
      auto, topLeft, topRight, bottomLeft, bottomRight, autoLeft, autoRight, topAuto, bottomAuto

      Default value is auto

      Specified by:
        `getJointPoint` in interface `PositionProps`

    - #### getDirection

          public abstract Positioning getDirection()

      Description copied from interface: `PositionProps`

      Set the direction of the popup. Possible values are:
      auto, topLeft, topRight, bottomLeft, bottomRight, autoLeft, autoRight, topAuto, bottomAuto

      Default value is auto

      Specified by:
        `getDirection` in interface `PositionProps`

    - #### isFollowMouse

          public abstract boolean isFollowMouse()

      If "true" tooltip should follow the mouse while it moves over the parent element. Default value is "true"

    - #### getHideDelay

          public abstract int getHideDelay()

      Delay in milliseconds before tooltip will be hidden. Default value is "0"

    - #### getHideEvent

          public abstract String getHideEvent()

      Event that triggers the tooltip disappearance. Default value is "mouseleave"

    - #### getHorizontalOffset

          public abstract int getHorizontalOffset()

      Sets the horizontal offset between pop-up list and mouse pointer. Default value is "10"
      Specified by:
        `getHorizontalOffset` in interface `PositionProps`

    - #### getMode

          public abstract TooltipMode getMode()

      Controls the way of data loading to a tooltip. May have following values: "client" (default) and "ajax"

    - #### getShowDelay

          public abstract int getShowDelay()

      Delay in milliseconds before tooltip will be displayed. Default value is "0"

    - #### getShowEvent

          public abstract String getShowEvent()

      Event that triggers the tooltip. Default value is "mouseenter"

    - #### getVerticalOffset

          public abstract int getVerticalOffset()

      Sets the vertical offset between pop-up list and mouse pointer. Default value is "10"
      Specified by:
        `getVerticalOffset` in interface `PositionProps`

    - #### getExecute

          public abstract Object getExecute()

      Description copied from interface: `AjaxProps`
      IDs of components that will participate in the "execute" portion of the Request Processing Lifecycle. Can be a single ID, a space or comma separated list of IDs, or an EL Expression evaluating to an array or Collection. Any of the keywords "@this", "@form", "@all", "@none", "@region" may be specified in the identifier list. Some components make use of additional keywords
      Default value is "@region" which resolves to this component if no region is present.
      Specified by:
        `getExecute` in interface `AjaxProps`

    - #### getZindex

          public abstract int getZindex()

      Description copied from interface: `PopupsProps`
      Attribute is similar to the standard HTML attribute and can specify window placement relative to the content. Default value is "3".
      Specified by:
        `getZindex` in interface `PopupsProps`

    - #### getConverter

          public abstract javax.faces.convert.Converter getConverter()

      Specified by:
        `getConverter` in interface `javax.faces.component.ValueHolder`
      Overrides:
        `getConverter` in class `javax.faces.component.UIOutput`

    - #### visitTree

          public boolean visitTree(javax.faces.component.visit.VisitContext context,
                                   javax.faces.component.visit.VisitCallback callback)

      Overrides:
        `visitTree` in class `javax.faces.component.UIComponent`

    - #### encodeMetaComponent

          public void encodeMetaComponent(javax.faces.context.FacesContext context,
                                          String metaComponentId)
                                   throws IOException

      Specified by:
        `encodeMetaComponent` in interface `MetaComponentEncoder`
      Throws:
        `IOException`

    - #### getContentClientId

          public String getContentClientId(javax.faces.context.FacesContext context)

    - #### resolveClientId

          public String resolveClientId(javax.faces.context.FacesContext facesContext,
                                        javax.faces.component.UIComponent contextComponent,
                                        String metaComponentId)

      Description copied from interface: `MetaComponentResolver`
      Resolves and returns string identifying supported meta-component or `null` if provided meta-component name is not a supported one.
      Specified by:
        `resolveClientId` in interface `MetaComponentResolver`
      Parameters:
        `facesContext` - - current instance of `FacesContext`
        `contextComponent` - - instance of `UIComponent` that requested resolution of meta-component
        `metaComponentId` - - name of meta-component (without leading '@' sign)
      Returns:
        clientId, one of supported meta-names such as @all, @this, etc. or `null`

    - #### substituteUnresolvedClientId

          public String substituteUnresolvedClientId(javax.faces.context.FacesContext facesContext,
                                                     javax.faces.component.UIComponent contextComponent,
                                                     String metaComponentId)

      Description copied from interface: `MetaComponentResolver`
      Provides replacement for unresolved meta-component names. Returns identifier string for the chosen substitution or `null`
      Specified by:
        `substituteUnresolvedClientId` in interface `MetaComponentResolver`
      Parameters:
        `facesContext` - - current instance of `FacesContext`
        `contextComponent` - - instance of `UIComponent` that requested resolution of meta-component
        `metaComponentId` - - name of meta-component (without leading '@' sign)
      Returns:
        clientId, one of supported meta-names such as @all, @this, etc. or `null`

Copyright © 2015 JBoss by Red Hat. All Rights Reserved.